{$V-}
{-------------------------------------------------------------------------}
{                             TICKLER                                     }
{-------------------------------------------------------------------------}
{                 Copyright 1986                                          }
{                               by Lynn A. Canning                        }
{                                  9107 Grandview Dr.                     }
{                                  Overland Park, Ks 66212                }
{-------------------------------------------------------------------------}
{$I WINDMNGR.INC}
{$I VIDOMODE.INC}
const
  Drive_path  :string[12] = '\';
  Infilename = 'TICKLER.DAT';
  Oldfilename = 'tickler.old';
  Outfilename = 'tickler.$$$';
  Julian : array [1..12] of integer =
               (000,031,060,091,121,152,182,213,244,274,305,335);
  montharr2 : array [1..12] of string[3] =
               ('Jan','Feb','Mar','Apr','May',
                'Jun','Jul','Aug','Sep','Oct','Nov','Dec');
  DayName   :array [1..7] of string[9] =
    ('Sunday','Monday','Tuesday','Wednesday','Thursday',
     'Friday','Saturday');
  todaylit             = ' Today     ';
  tomorrowlit          = ' Tomorrow  ';
  spcelit              = '           ';
  Max_Table_Entries    = 200;

type
  RegRec =                               { The data to pass to DOS }
    record
      AX, BX, CX, DX, BP, SI, DI, DS, ES, Flags : Integer;
    end;
  HalfRegtype = record Al,Ah,Bl,Bh,Cl,Ch,Dl,Dh:byte              end;
  CharSet     = set of Char;
  AnyStr      = string[75];
  Str50       = string[50];
  EditRec    =  string[75];
  EditArray     = array[1..Max_Table_Entries] of EditRec;

  DataRecord = Record
    Jdate          :string[3];
    AmPm           :string[2];
    Time           :string[5];
    Timespan       :string[2];
    DOW            :string[1];
    DelInd         :string[1];
    Gday           :string[2];
    Gmon           :string[2];
    Gyr            :string[4];
    Reserved       :string[3];
    TickMessage    :string[50];
  End;

var
  Infile,Outfile      :text;
  InRec                :EditArray;
  InWork               :string[75];
  I,J,M,W,D,T,cx,cy    :integer;
  Regs                 :RegRec;
  HalfRegs             :HalfRegType absolute Regs;
  datestr              :string[30];
  datarec              :DataRecord;
  daylit               :string[10];
  Jday                 :string[3];
  Mday,Mmon,Mampm,Mts  :string[2];
  Mwkday,parm,Mst      :string[1];
  Myr                  :string[4];
  Mtime                :string[5];
  Mmesg                :string[50];
  year:string[4];
  top,bottom,pspan,
  tmpday,tmpwkday,
  tmpmonth,Len,
  today,juldate,result,
  tspan,difdate,hour,
  tdsw,tmsw,otsw,lines :integer;
  day,printspan        :string[2];
  ch,TC                :char;
  oldfile,printpurged,
  delpurged,
  goodfile,goodinp,
  printp,SaveSw,
  done,purge           :boolean;

{----------------------------------------------------------------------------}
{                   Get System Date                                          }
{----------------------------------------------------------------------------}
procedure date;           { What is todays date }
const
  montharr  :array [1..12] of string[9] =
             ('January', 'February', 'March', 'April', 'May', 'June', 'July',
              'August', 'September', 'October', 'November', 'December');

var
    regs:regrec;
    month, day:string[2];
    wkday:string[1];
    dx, cx, result     :integer;

begin
    with regs do
    begin
      ax:= $2a shl 8;
    end;
    msdos (regs);
    with regs do
    begin
      str(cx:4, year);
      str(dx shr 8:2, month);
      str(dx mod 256:2, day);
      str(ax mod 256,wkday);
    end;
    val(wkday,tmpwkday,result);
    tmpwkday := tmpwkday + 1;
    if month[1] = ' ' then month[1] := '0';
    val(month, tmpmonth, result);
    datestr:=  DayName[tmpwkday]+', ' +montharr[tmpmonth]+ ' '+day+', '+year;
    if day[1] = ' ' then day[1] := '0';
    Val(day,tmpday,result);
    today := tmpday + Julian[tmpmonth];
end; { procedure date }

{ -------------------
  CURSOROFF procedure
  ------------------- }
Procedure CursorOff;
begin
   with regs do
   begin
      cx := $2000;
      ax := $0100;
      intr($10,regs);
   end;
end;

{ -------------------
  CURSORON procedure
  ------------------- }
Procedure CursorOn;
begin
   with regs do
   begin
      if VideoStatus = 7 then
         cx := $0C0D
      else
         cx := $0607;
      ax := $0100;
      intr($10,regs);
   end;
end;{----------------------------------------------------------------------------}
{                           SORT ARRAY ROUTINES                              }
{----------------------------------------------------------------------------}

Procedure Sort_List (var values : EditArray; lo, hi : integer);
  var  new_lo,
       new_hi    : integer;   { used to divide the array of values }
       center_value,
       hold_value    :EditRec;   { used when values are swapped }

  Procedure Swap_Values (Low, High: integer);
    var hold_value  :EditRec;
    begin
      hold_value := values[low];
      values[low] := values[high];
      values[high] := hold_value;
    end;  {  Swap_Values  }

  Procedure Divide_Array(left, right: integer);
    var center_value,
        hold_value  : EditRec;
    begin
      center_value := values[(hi + lo) div 2];
      left := lo; right := hi;
      while (left <= right) do
      begin
        while(values[left] < center_value) do
          left := Succ(left);
        while(values[right] > center_value) do
          right := Pred(right);
        if (left <= right) then
        begin
          Swap_Values(left,right);
          left := Succ(left);
          right := Pred(right);
        end;  { if }
      end;  { while }
      new_lo := left;
      new_hi := right;
    end;  { divide_array }

  begin   { SortList  }
    if ((hi - lo) > 1) then
    begin
      Divide_Array(lo,hi);
      Sort_List(values,lo,new_hi);
      Sort_List(values,new_lo,hi);
    end
    else
      if ((hi - lo) = 1) then
        if (values[hi] < values[lo]) then
           Swap_Values(lo,hi);
    end;  {  Sort_List  }

  {  end of Sort_List routine  }
{----------------------------------------------------------------------------}
{                             STATUS ROUTINES                                }
{----------------------------------------------------------------------------}
procedure SetRec(Delswitch : integer);
begin
  With DataRec Do
    begin
          Jdate         := copy(inrec[J],1,3);
          AmPm          := copy(inrec[J],4,2);
          Time          := copy(inrec[J],6,5);
          TimeSpan      := copy(inrec[J],11,2);
          DOW           := copy(inrec[J],13,1);
          DelInd        := copy(inrec[J],14,1);
          Gday          := copy(inrec[J],15,2);
          Gmon          := copy(inrec[J],17,2);
          Gyr           := copy(inrec[J],19,4);
          Tickmessage   := copy(inrec[J],26,50);
      if (Delswitch = 1) and (DelInd = 'D') then
        begin
          Time := 'DELET';
          AmPm := 'ED';
        end;
    end;
end;

procedure WriteOutput;
begin
  InWork := inrec[J];
  if InWork[14] = 'P' then
    begin
      SetRec(0);
      With DataRec DO
        begin
          writeln(Outfile,Gmon+'/'+Gday+'/'+Gyr+' '+Time+AmPm+' '+Tickmessage);
          if printpurged then
            writeln(Lst,Gmon+'/'+Gday+'/'+Gyr+' '+Time+AmPm+' '+Tickmessage);
        end
    end
  else
    if not (InWork[14] = 'D') then
      writeln(InFile,InWork);
end;

procedure ResetInput;
begin
  Str(juldate:3,Jday);
  if Jday[1] = ' ' then
    InWork[1] := '0'
  else
    InWork[1] := Jday[1];
  if Jday[2] = ' ' then
    InWork[2] := '0'
  else
    InWork[2] := Jday[2];
  InWork[3] := Jday[3];
  Str(M:2,Mmon);
  if Mmon[1] = ' ' then
    InWork[17] := '0';
  InWork[18] := Mmon[2];
end;

procedure Quarterly;
begin
  M := M-12;
  repeat
    begin
      M := M+3;
      if tmpmonth > M then
        done := false
      else
        done := true;
    end;
  until done;
  if M = 13 then
    M := M-12;
  juldate := D+Julian[M];
  ResetInput;
end;

procedure monthly;
begin
  if tmpday > D then
    M := tmpmonth+1
  else
    M := tmpmonth;
  if M = 13 then
    M := 1;
  juldate := D+Julian[M];
  ResetInput;
end;

procedure weekly;
begin
  if tmpwkday > W then
    W := W+7;
  difdate := W - tmpwkday;
  juldate := today + difdate;
  if juldate > 366 then
    juldate := juldate - 366;
  done := false;
  M := 0;
  repeat
    M := M+1;
    if Julian[M]+31 > Juldate then
      done := true;
  until done;
  D := Juldate - Julian[M];
  Str(D:2,Mday);
  if Mday[1] = ' ' then
    Inwork[15] := '0'
  else
    Inwork[15] := Mday[1];
  Inwork[16] := Mday[2];
  ResetInput;
end;

procedure GetInfile;
begin
  ClrScr;
  Assign(Infile,Drive_path+Infilename);
  {$I-}
  Reset(Infile);
  {$I+}
  if IOResult = 0 then
    goodfile := true
  else
    begin
      goodfile := false;
      gotoxy(2,2);
      write('Input file ');
      textcolor(Rxx);
      write(Drive_path+Infilename);
      textcolor(Yxx);
      writeln(' Not Found ');
      write(' Enter Drive and Path for ');
      textcolor(LtRxx);
      write(Infilename);
      gotoxy(2,4);
      readln(Drive_path);
    end;
end;

{----------------------------------------------------------------------------}
{                          STRING EDITOR                                     }
{----------------------------------------------------------------------------}
function ConstStr(C : Char; N : Integer) : Str50;
var
  S : string[50];
begin
  if N < 0 then
    N := 0;
  S[0] := Chr(N);
  FillChar(S[1],N,C);
  ConstStr := S;
end;

procedure Beep;
begin
  Write(^G);
end;

procedure InputStr(var S     : AnyStr;
                       L,X,Y : Integer;
                       Term  : CharSet;
                   var TC    : Char    );
const
  UnderScore  =  '_';
var
  P : Integer;
  Ch : Char;
begin
  GotoXY(X,Y); Write(S,ConstStr(UnderScore,L - Length(S)));
  P := 0;
  repeat
    GotoXY(X + P,Y); Read(Kbd,Ch);
    case Ch of
      #27       : begin
                    Read(Kbd,Ch);
                    case Ch of
                      'K'  :  if P > 0 then P := P -1
                                else Beep;
                      'M'  :  if P < length(S) then P := P + 1
                                else Beep;
                      'G'  :  P := 0;
                      'O'  :  P := length(S);
                      'S'  :  if P < length(S) then
                                begin
                                   Delete(S,P+1,1);
                                   Write(Copy(S,P+1,L),UnderScore);
                                end
                    else Beep;
                    end;   { of case }
                 end;
      #32..#126 : if P < L then
                  begin
                    if Length(S) = L then
                      Delete(S,L,1);
                    P := P + 1;
                    Insert(Ch,S,P);
                    Write(Copy(S,P,L));
                  end
                  else Beep;
       ^H,#127 : if P > 0 then
                  begin
                    Delete(S,P,1);
                    Write(^H,Copy(S,P,L),UnderScore);
                    P := P - 1;
                  end
                  else Beep;
     ^Y       : begin
                  Write(ConstStr(UnderScore,Length(S) - P));
                  Delete(S,P + 1,L);
                 end;
    else
      if not (Ch in Term) then Beep;
    end;  {of case}
  until Ch in Term;
  P := Length(S);
  GotoXY(X + P,Y);
  Write('' :L - P);
  TC := Ch;
end;

procedure SaveRec;
begin
  SaveSw := True;
  Juldate := D + Julian[M];
  Str (Juldate:3,Jday);
  if Jday[1] = ' ' then
    Jday[1] := '0';
  if Jday[2] = ' ' then
    Jday[2] := '0';
  InWork := Jday+Mampm+Mtime+Mts+Mwkday+Mst+Mday+Mmon+Myr+'   '+Mmesg;
  I := I+1;
  inrec[I] := Inwork;
end;

procedure ResetAddRec;
begin
  Mday := '00';
  Mmon := '00';
  Myr  := year;
  Mtime := '_____';
  Mampm := '__';
  Mmesg := '';
  Mts := '00';
  Mst := 'T';
  Mwkday := ' ';
end;

procedure ResetChangeRec;
begin
  with DataRec DO
  begin
    Mday := Gday;
    Mmon := Gmon;
    Myr  := Gyr;
    Mtime := Time;
    Mampm := AmPm;
    Mmesg := TickMessage;
    Mts := Timespan;
    Mst := DelInd;
    Mwkday := DOW;
    writexy(Mmon,Cxx,4,7,0);
    writexy(Mday,Cxx,9,7,0);
    writexy(Myr,Cxx,13,7,0);
    writexy(Mtime,Cxx,18,7,0);
    writexy(Mampm,Cxx,24,7,0);
    writexy(Mmesg,Cxx,28,7,0);
    writexy(Mts,Cxx,6,10,0);
    writexy(Mst,Cxx,15,10,0);
    if (Mst = 'W') then
      begin
        writexy(' DOW',Gxx,20,9,0);
        writexy(Mwkday,Cxx,22,10,0);
      end;
  end;
end;

procedure edit;
const
  Term : CharSet = [^M,^Z];
begin
  CursorOn;
  goodinp := false;
  writexy(' MONTH DAY YEAR   TIME    MESSAGE',Gxx,2,6,0);
  writexy(' TIMESPAN  STATUS',Gxx,2,9,0);
  writexy('Enter message month, Press Return',LtWxx,15,12,0);
  repeat
    repeat
      InputStr(Mmon,2,3,3,Term,TC);
    until TC in Term;
    Val(Mmon,M,result);
    if (M >= 1) and (M <= 12) then
      goodinp := true
    else begin
      Beep;
      writexy('  Invalid. Re-enter, ',LtRxx,15,12,0);
      end
  until goodinp;
  goodinp:= false;
  writexy('  Enter message day,',LtWxx,15,12,0);
  repeat
    repeat
      InputStr(Mday,2,8,3,Term,TC);
    until TC in Term;
    Val(Mday,D,result);
    if (D >= 1) and (D <= 31) then
      goodinp := true
    else begin
      Beep;
      writexy('  Invalid. Re-enter, ',LtRxx,15,12,0);
      end
  until goodinp;
  goodinp := false;
  writexy(' Enter message year, ',LtWxx,15,12,0);
  repeat
    InputStr(Myr,4,12,3,Term,TC);
  until TC in Term;
  writexy(' Enter time (hh:mm), ',LtWxx,15,12,0);
  repeat
    InputStr(Mtime,5,17,3,Term,TC);
  until TC in Term;
  if Mtime = '_____' then
    Mtime := '     ';
  writexy('    Enter AM or PM,  ',LtWxx,15,12,0);
  repeat
    InputStr(Mampm,2,23,3,Term,TC);
  until TC in Term;
  if Mampm = '__' then
    Mampm := '  ';
  writexy('     Enter Message,  ',LtWxx,15,12,0);
  repeat
    InputStr(Mmesg,50,27,3,Term,TC);
  until TC in Term;
  writexy('Enter Number of Days in Advance to show Message (00-99)',LtWxx,15,12,0);
  repeat
    InputStr(Mts,2,5,6,Term,TC);
  until TC in Term;
  writexy('Enter Message Status (A=Annual Q=Qtr M=Mon W=Wk T=Temp)',LtWxx,15,12,0);
  repeat
    InputStr(Mst,1,14,6,Term,TC);
  until TC in Term;
  Mst := UpCase(Mst);
  if Mst = 'W' then
    begin
      goodinp :=false;
      writexy(' DOW',Gxx,20,9,0);
      writexy('Enter day of week for message (1=Sunday 2=Monday, etc.)',LtWxx,15,12,0);
      repeat
        repeat
          InputStr(Mwkday,1,21,6,Term,TC);
        until TC in Term;
        Val(Mwkday,W,result);
        if W in [1..7] then
          goodinp := true
        else begin
          Beep;
          writexy('Invalid. Re-enter, using  --  ',LtRxx,15,12,0);
          end
        until goodinp;
      end;
  writexy('                                                          ',LtWxx,15,12,0);
  repeat
    writexy('Save this message as it now appears? Y/N  ',LtGxx,15,12,0);
    gotoxy(56,8);
    Read(Kbd,ch);
    ch := UpCase(ch);
  until ch in ['N','Y'];
  if ch = 'Y' then
    SaveRec;
  Remove(1);
end;

procedure Modify;
begin
  CursorOff;
  gotoxy(1,1);
  done := false;
  J := 0;
  repeat
    J := J+1;
    SetRec(1);
    with DataRec DO
      writeln(Gmon+'/'+Gday+'/'+Gyr+' '+Time+AmPm+' '+Tickmessage);
    if (J = I) or (J = 17) then
      done := true;
  until done;
  Bottom := J;
  Top := 1;
  J := 1;
  T := 5;
  done := false;
  SetRec(1);
  with datarec do
  Inwork := Gmon+'/'+Gday+'/'+Gyr+' '+Time+AmPm+' '+Tickmessage;
  writexy(Inwork,Yxx,2,5,0);
  Writexy(' Select Message and Press C to Change, D to Delete, or X to Exit ',LtRxx,8,24,0);
  textcolor(Yxx);
  repeat
    Read(Kbd,ch);
    CASE Ch of
      #27     : begin
                  Read(Kbd,Ch);
                  case Ch of
                    'H'  :  begin  {up arrow}
                              if J > 1 then
                                begin
                                  writexy(Inwork,Mxx,2,T,0);
                                  J := J-1;
                                  SetRec(1);
                                    with datarec do
                                    Inwork := Gmon+'/'+Gday+'/'+Gyr+' '+Time+AmPm+' '+Tickmessage;
                                  if T = 5 then
                                    begin
                                      gotoxy(1,1);
                                      top := top - 1;
                                      bottom := bottom - 1;
                                      Insline;
                                      writeln(Inwork);
                                    end
                                  else
                                    begin
                                      T := T-1;
                                      writexy(Inwork,Yxx,2,T,0);
                                    end
                                end
                            end;
                    'P'  :  begin  {down arrow}
                              if J < I then
                                begin
                                  writexy(Inwork,Mxx,2,T,0);
                                  J := J+1;
                                  gotoxy(1,18);
                                  SetRec(1);
                                    with datarec do
                                    Inwork := Gmon+'/'+Gday+'/'+Gyr+' '+Time+AmPm+' '+Tickmessage;
                                  if T = 21 then
                                    begin
                                      top := top + 1;
                                      bottom := J;
                                      writeln(Inwork);
                                    end
                                  else
                                    begin
                                      T := T+1;
                                      writexy(Inwork,Yxx,2,T,0);
                                    end
                                end
                            end;
                    'I'  :  begin  {page up}
                             if top > 1 then
                              begin
                               gotoxy(1,1);
                               done := false;
                               if top > 17 then
                                 J := top - 18
                               else
                                 J := 0;
                               top := J+1;
                               ClrScr;
                               textcolor(Mxx);
                               repeat
                                J := J+1;
                                SetRec(1);
                                with DataRec DO
                                 writeln(Gmon+'/'+Gday+'/'+Gyr+' '+Time+AmPm+' '+Tickmessage);
                                if J = top+16 then
                                  done := true;
                               until done;
                               Bottom := J;
                               J := top;
                               T := 5;
                               done := false;
                               SetRec(1);
                               with datarec do
                                Inwork := Gmon+'/'+Gday+'/'+Gyr+' '+Time+AmPm+' '+Tickmessage;
                               writexy(Inwork,Yxx,2,5,0);
                               textcolor(Yxx);
                              end;
                            end;
                    'Q'  :  begin  {page down}
                             if bottom < I then
                              begin
                               gotoxy(1,1);
                               done := false;
                               J := bottom;
                               top := J+1;
                               ClrScr;
                               textcolor(Mxx);
                               repeat
                                J := J+1;
                                SetRec(1);
                                with DataRec DO
                                 writeln(Gmon+'/'+Gday+'/'+Gyr+' '+Time+AmPm+' '+Tickmessage);
                                if (J = I) or (J = bottom+17) then
                                  done := true;
                               until done;
                               Bottom := J;
                               J := top;
                               T := 5;
                               done := false;
                               SetRec(1);
                               with datarec do
                                Inwork := Gmon+'/'+Gday+'/'+Gyr+' '+Time+AmPm+' '+Tickmessage;
                               writexy(Inwork,Yxx,2,5,0);
                               textcolor(Yxx);
                              end;
                            end;
                  end; {end case}
                end;
      'C','c' : begin
                  with datarec do
                  Len := Length(TickMessage);
                  Open(3);
                  SetRec(0);
                  ResetChangeRec;
                  edit;
                  CursorOff;
                  if ch = 'Y' then
                    begin
                      inrec[J] := inrec[I];
                      I := I-1;
                      SetRec(1);
                      with datarec do
                        Inwork := Gmon+'/'+Gday+'/'+Gyr+' '+Time+AmPm+' '+Tickmessage;
                      gotoxy(1,T-4);
                      textcolor(LtGxx);
                      write(Inwork);
                      write(' ':50-Len);
                      SaveSw := true;
                    end;
                end;
      'D','d' : begin
                  Inwork := inrec[J];
                  Inwork[14] := 'D';
                  inrec[J] := Inwork;
                  SetRec(1);
                  with datarec do
                    Inwork := Gmon+'/'+Gday+'/'+Gyr+' '+Time+AmPm+' '+Tickmessage;
                  writexy(Inwork,LtRxx,2,T,0);
                  SaveSw := true;
                end;
      'X','x' : done := true;
    ELSE
      done := false;
    END; {end case}
  until done;
  ClrScr;
  Writexy('',LtWxx,8,24,0);
end;

procedure EditWindow;
begin
  ClrScr;
  CursorOn;
  Writexy('EDITOR  ',YBrxx,13,2,0);
  Open(2);
  Writexy('Tickler Edit Menu',LtRxx,29,8,0);
  Writexy('  Version 2.00   ',LtGxx,29,9,0);
  Writexy('A = Add a Message',Rxx,24,11,0);
  Writexy('M = Change or Delete a Message',Mxx,24,12,0);
  Writexy('P = Print Purged Messages File',Cxx,24,13,0);
  Writexy('O = Delete Purged Messages File',Brxx,24,14,0);
  Writexy('X = Exit to DOS',Yxx,24,16,0);
  Writexy('Option Wanted:',LtWxx,31,18,0);
  if printpurged then
    writexy('On',LtRBlxx+FLASH,21,13,0);
  if delpurged then
    writexy('On',LtRBlxx+FLASH,21,14,0);
  gotoxy(29,12);
  Read(Kbd,ch);
  ch := UpCase(ch);
  Remove(1);
  CASE ch of
    'A' :begin
           repeat
             ResetAddRec;
             Open(3);
             edit;
             writexy('Add another message? Y/N',LtRxx,15,12,0);
             gotoxy(39,8);
             repeat
               Read(Kbd,ch);
             until ch in ['Y','y','N','n'];
           until ch in ['N','n'];
           CursorOff;
         end;
    'M' :Modify;
    'P' :if printpurged then
           printpurged := false
         else
           printpurged := true;
    'O' :if delpurged then
           delpurged := false
         else
           delpurged := true;
  ELSE
    Beep;
  END; {end case}
  ClrScr;
  CursorOff;
end;

{----------------------------------------------------------------------------}
{                          MAIN PROGRAM                                      }
{----------------------------------------------------------------------------}
BEGIN
  Initialize;
  SetVideo;
  SetWindow(1,1,4,78,23,LtGxx,Mxx,2,1,'',0,0,2);
  SetWindow(2,16,6,62,21,LtBlxx,LtWxx,8,1,'',0,0,2);
  SetWindow(3,1,4,78,23,Cxx,Mxx,2,1,'',0,0,2);
  Frame(0,0,79,24,LtWxx,0,2,0,0,0);
  Frame(1,1,78,3,BlBrxx,BkBrxx,2,0,0,0);
  Open(1);
  Date;
  Writexy('TICKLER MESSAGES',LtCBrxx,5,2,0);
  Writexy(datestr,LtMBrxx,28,2,0);
  Writexy('(C) Lynn Canning 1986',YBrxx,56,2,0);
  printpurged := false;
  delpurged := false;
  purge := false;
  repeat
    GetInfile;
  until goodfile;
  if (param1 = 'S') or (param2 = 'S') then
    begin
      writexy('Enter Time Span for Printed Schedule (00 - 99)',LtMxx,15,12,0);
      gotoxy(61,8);
      read(printspan);
      Val(printspan,pspan,result);
      Writeln(Lst,'SCHEDULE FOR THE NEXT '+printspan+' DAYS');
    end;
  ClrScr;
  CursorOff;
  gotoxy(1,1);
  tdsw := 0;
  tmsw := 0;
  otsw := 0;
  lines := 0;
  I := 0;
  while not EOF(Infile) DO
    begin
      I := I + 1;
      Readln(Infile,InWork);
      Mday := copy(InWork,15,2);
      Mmon := copy(InWork,17,2);
      Mwkday := InWork[13];
      Val(Mday,D,result);
      Val(Mmon,M,result);
      Val(Mwkday,W,result);
      If InWork[14] = 'Q' then
        Quarterly;
      If InWork[14] = 'M' then
        Monthly;
      If InWork[14] = 'W' then
        Weekly;
      ch := InWork[14];
      if ch in ['A','Q','M','W'] then
        begin
          delete(Inwork,19,4);
          insert(year,Inwork,19);
        end
      else
        InWork[14] := 'T';
      InRec[I] := InWork;
    end;
  close(infile);
  Sort_List(Inrec,1,I);
  for J := 1 to I DO
    begin
      SetRec(0);
      With DataRec DO
      begin
      if Gday[1] = '0' then
        Gday[1] := ' ';
      Val(Jdate,juldate,result);
      Val(Timespan,tspan,result);
      if DelInd = 'T' then
       begin
        if Gyr < year then
          begin
            InWork := inrec[J];
            Inwork[14] := 'P';
            inrec[J] := InWork;
            purge := true;
          end
        else
          if Gyr = year then
            if today > juldate then
              begin
                InWork := inrec[J];
                Inwork[14] := 'P';
                inrec[J] := InWork;
                purge := true;
              end;
       end;
      if today > juldate then
        Juldate := Juldate + 366;
      difdate := juldate - today;
      Val(Gmon,M,result);
      if (param1 = 'S') or (param2 = 'S') then
        if difdate <= pspan then
          writeln(Lst,Gday+' '+montharr2[M]+' '+Time+AmPm+' '+Tickmessage);
      if difdate <= tspan then
        begin
          if difdate > 0 then
            if tdsw = 0 then
              begin
                tdsw := 1;
                textcolor(LtRxx);
                write(todaylit);
                textcolor(Brxx);
                writeln('            No Messages for Today');
                writeln;
                lines := lines+2;
              end;
          if difdate > 1 then
            if tmsw = 0 then
              begin
                tmsw := 1;
                writeln;
                textcolor(LtRxx);
                write(tomorrowlit);
                textcolor(Brxx);
                writeln('            No Messages for Tomorrow');
                writeln;
                lines := lines+3;
              end;
          if difdate = 0 then
            if tdsw = 0 then
              begin
                tdsw := 1;
                daylit := todaylit;
                textcolor(LtCxx);
              end
            else
              daylit := spcelit;
          if difdate = 1 then
            if tmsw = 0 then
              begin
                writeln;
                lines := lines+1;
                tmsw := 1;
                daylit := tomorrowlit;
                textcolor(LtCxx);
              end
            else
              daylit := spcelit;
          if difdate > 1 then
            if otsw = 0 then
              begin
                writeln;
                lines := lines+1;
                otsw := 1;
              end;
          if difdate > 1 then
            begin
              if DelInd = 'W' then
                begin
                  Val(DOW,W,result);
                  daylit := ' '+dayname[W];
                end
              else
                daylit := ' '+Gday+' '+montharr2[M]+'   ';
              textcolor(LtCxx);
            end;
          lines := lines+1;
          if lines = 17 then
            begin
              lines := 1;
              writeln(' More - Press any key to continue');
              repeat until keypressed;
              gotoxy(1,17);
            end;
          write(daylit,'':10-Length(daylit),'  ');
          textcolor(Gxx);
          write(Time+' '+AmPm);
          textcolor(Mxx);
          writeln('   '+TickMessage);
        end;
     end;
   end;
  textcolor(LtCxx+FLASH);
  if (tdsw = 0) and (tmsw = 0) and (otsw = 0) then
    writeln(' No Messages scheduled for Today');
  Writexy(' Press E to Edit, or any other key to Exit: ',LtRxx,18,24,0);
  Read(Kbd,ch);
  ch := UpCase(ch);
  Writexy('',LtWxx,18,24,0);
  if ch = 'E' then
      repeat EditWindow;
        until ch = 'X';
  ClrScr;
  if (param1 = 'S') or (param2 = 'S') then
    writeln(Lst,#$0C);
  writexy('Wait! - Cleaning Up Data Files',LtWxx+FLASH,25,13,0);
  if purge or printpurged then
    begin
      oldfile := false;
      assign(Outfile,drive_path+Outfilename);
      Rewrite(Outfile);
     if printpurged then
       writeln(Lst,'PURGED MESSAGES as of '+datestr);
      assign(Infile,drive_path+Oldfilename);
      {$I-}
      reset(Infile);
      {$I+}
      if IOResult = 0 then
        While not EOF(Infile) DO
          begin
            oldfile := true;
            readln(Infile,Inwork);
            writeln(Outfile,Inwork);
            if printpurged then
              writeln(Lst,Inwork);
          end;
      Close(Infile);
      if oldfile then
        Erase(Infile);
      assign(Infile,drive_path+Infilename);
    end;
  if purge or savesw then
    begin
      Rewrite(InFile);
      For J := 1 to I DO
        WriteOutput;
      close(InFile);
    end;
  if purge or printpurged then
    begin
      Close(Outfile);
      Rename(Outfile,drive_path+Oldfilename);
    end;
  if delpurged then
    Erase(Outfile);
  if printpurged then
    writeln(Lst,#$0C);
  remove(1);
  ClrScr;
  CursorOn;
  end.

